searchData={"content_type":"text/markdown","items":[{"doc":"Mix task to download database file(s) from your command line.","ref":"Mix.Tasks.UaInspector.Download.html","title":"mix ua_inspector.download","type":"task"},{"doc":"When run without arguments the task will display the target directory for the\ndownloaded files and will ask for confirmation before downloading.\n\n- `--force`: skip confirmation before downloading\n- `--quiet`: silences task output (does not imply `--force`!)","ref":"Mix.Tasks.UaInspector.Download.html#module-arguments","title":"Arguments - mix ua_inspector.download","type":"task"},{"doc":"If you are using the default databases from the default remote location an\ninformational README with the filename `ua_inspector.readme.md` will be\nplaced next to the downloaded file(s). Inside you will find a link to the\noriginal database source.\n\nThe creation of this file can be deactivated by configuration:\n\n    config :ua_inspector,\n      skip_download_readme: true","ref":"Mix.Tasks.UaInspector.Download.html#module-informational-readme","title":"Informational README - mix ua_inspector.download","type":"task"},{"doc":"If you are using the default databases from the default remote location an\ninformational release file will be placed next to the downloaded file(s).\nInside you will find the remote release version configured for the download.\n\nThe creation of this file can be deactivated by configuration:\n\n    config :ua_inspector,\n      skip_download_release: true","ref":"Mix.Tasks.UaInspector.Download.html#module-release-information","title":"Release Information - mix ua_inspector.download","type":"task"},{"doc":"User agent parser library.","ref":"UAInspector.html","title":"UAInspector","type":"module"},{"doc":"1. Verify your supervision setup according to `UAInspector.Supervisor`\n2. Revise the default configuration values of `UAInspector.Config` and\n   adjust to your project/environment where necessary\n3. Download a copy of the database files as outlined in\n   `UAInspector.Downloader`\n\nPlease re-download (or otherwise update your copy of) the database\nif the default `:remote_release` in `UAInspector.Config` changes.","ref":"UAInspector.html#module-preparation","title":"Preparation - UAInspector","type":"module"},{"doc":"The map key `:user_agent` will hold the unmodified passed user agent.\n\nIf the device type cannot be determined a \"desktop\" device type will be\nassumed (and returned). Both `:brand` and `:model` are set to `:unknown`.\n\nWhen a bot agent is detected the result with be a `UAInspector.Result.Bot`\nstruct instead of `UAInspector.Result`.\n\n#","ref":"UAInspector.html#module-usage","title":"Usage - UAInspector","type":"module"},{"doc":"iex> UAInspector.parse(\"Mozilla/5.0 (iPad; CPU OS 7_0_4 like Mac OS X) AppleWebKit/537.51.1 (KHTML, like Gecko) Version/7.0 Mobile/11B554a Safari/9537.53\")\n    %UAInspector.Result{\n      browser_family: \"Safari\",\n      client: %UAInspector.Result.Client{\n        engine: \"WebKit\",\n        engine_version: \"537.51.1\",\n        name: \"Mobile Safari\",\n        type: \"browser\",\n        version: \"7.0\"\n      },\n      device: %UAInspector.Result.Device{\n        brand: \"Apple\",\n        model: \"iPad\",\n        type: \"tablet\"\n      },\n      os: %UAInspector.Result.OS{\n        name: \"iOS\",\n        platform: :unknown,\n        version: \"7.0.4\"\n      },\n      os_family: \"iOS\",\n      user_agent: \"Mozilla/5.0 (iPad; CPU OS 7_0_4 like Mac OS X) AppleWebKit/537.51.1 (KHTML, like Gecko) Version/7.0 Mobile/11B554a Safari/9537.53\"\n    }\n\n#","ref":"UAInspector.html#module-basic-user-agent-lookup","title":"Basic User Agent Lookup - UAInspector","type":"module"},{"doc":"iex> client_hints = UAInspector.ClientHints.new([\n    ...>   {\"sec-ch-ua\", ~S(\" Not A;Brand\";v=\"99\", \"Chromium\";v=\"95\", \"Microsoft Edge\";v=\"95\")},\n    ...>   {\"sec-ch-ua-mobile\", \"?0\"},\n    ...>   {\"sec-ch-ua-platform\", \"Windows\"},\n    ...>   {\"sec-ch-ua-platform-version\", \"14.0.0\"}\n    ...> ])\n    iex> UAInspector.parse(\"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.69 Safari/537.36 Edg/95.0.1020.44\", client_hints)\n    %UAInspector.Result{\n      browser_family: \"Internet Explorer\",\n      client: %UAInspector.Result.Client{\n        engine: \"Blink\",\n        engine_version: \"95.0.4638.69\",\n        name: \"Microsoft Edge\",\n        type: \"browser\",\n        version: \"95.0.1020.44\"\n      },\n      device: %UAInspector.Result.Device{\n        brand: :unknown,\n        model: :unknown,\n        type: \"desktop\"\n      },\n      os: %UAInspector.Result.OS{\n        name: \"Windows\",\n        platform: \"x64\",\n        version: \"10\"\n      },\n      os_family: \"Windows\",\n      user_agent: \"Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/95.0.4638.69 Safari/537.36 Edg/95.0.1020.44\"\n    }\n\n    iex> client_hints = UAInspector.ClientHints.new([{\"x-requested-with\", \"org.telegram.messenger\"}])\n    iex> UAInspector.parse(\"Mozilla/5.0 (Linux; Android 11; Pixel 3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/92.0.4515.131 Mobile Safari/537.36\", client_hints)\n    %UAInspector.Result{\n      browser_family: :unknown,\n      client: %UAInspector.Result.Client{\n        engine: :unknown,\n        engine_version: :unknown,\n        name: \"Telegram\",\n        type: \"mobile app\",\n        version: :unknown\n      },\n      device: %UAInspector.Result.Device{\n        brand: \"Google\",\n        model: \"Pixel 3\",\n        type: \"smartphone\"\n      },\n      os: %UAInspector.Result.OS{\n        name: \"Android\",\n        platform: :unknown,\n        version: \"11\"\n      },\n      os_family: \"Android\",\n      user_agent: \"Mozilla/5.0 (Linux; Android 11; Pixel 3) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/92.0.4515.131 Mobile Safari/537.36\"\n    }\n\n#","ref":"UAInspector.html#module-lookup-with-additional-client-hints","title":"Lookup with Additional Client Hints - UAInspector","type":"module"},{"doc":"iex> UAInspector.parse(\"Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36\")\n    %UAInspector.Result.Bot{\n      category: \"Search bot\",\n      name: \"Googlebot\",\n      producer: %UAInspector.Result.BotProducer{\n        name: \"Google Inc.\",\n        url: \"http://www.google.com\"\n      },\n      url: \"http://www.google.com/bot.html\",\n      user_agent: \"Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36\"\n    }\n\n    iex> UAInspector.parse(\"generic crawler agent\")\n    %UAInspector.Result.Bot{\n      category: :unknown,\n      name: \"Generic Bot\",\n      producer: %UAInspector.Result.BotProducer{\n        name: :unknown,\n        url: :unknown\n      },\n      url: :unknown,\n      user_agent: \"generic crawler agent\"\n    }\n\n#","ref":"UAInspector.html#module-bot-result","title":"Bot Result - UAInspector","type":"module"},{"doc":"iex> UAInspector.parse(\"--- undetectable ---\")\n    %UAInspector.Result{\n      browser_family: :unknown,\n      client: :unknown,\n      device: :unknown,\n      os: :unknown,\n      os_family: :unknown,\n      user_agent: \"--- undetectable ---\"\n    }","ref":"UAInspector.html#module-unknown-user-agent","title":"Unknown User Agent - UAInspector","type":"module"},{"doc":"Checks if a user agent is a known bot.","ref":"UAInspector.html#bot?/2","title":"UAInspector.bot?/2","type":"function"},{"doc":"Checks if a user agent is a desktop device.","ref":"UAInspector.html#desktop?/2","title":"UAInspector.desktop?/2","type":"function"},{"doc":"Checks if a user agent is a HbbTV and returns its version if so.","ref":"UAInspector.html#hbbtv?/2","title":"UAInspector.hbbtv?/2","type":"function"},{"doc":"Checks if a user agent is a mobile device.","ref":"UAInspector.html#mobile?/2","title":"UAInspector.mobile?/2","type":"function"},{"doc":"Parses a user agent.","ref":"UAInspector.html#parse/2","title":"UAInspector.parse/2","type":"function"},{"doc":"Parses a user agent without checking for bots.","ref":"UAInspector.html#parse_client/2","title":"UAInspector.parse_client/2","type":"function"},{"doc":"Checks if UAInspector is ready to perform lookups.\n\nThe `true == ready?` definition is made on the assumption that if there is\nat least one entry in all databases then lookups can be performed.\n\nChecking the state is done using the currently active databases.\nAny potentially concurrent reload requests are not considered.","ref":"UAInspector.html#ready?/0","title":"UAInspector.ready?/0","type":"function"},{"doc":"Reloads all databases.\n\nYou can pass `[async: true|false]` to define if the reload should happen\nin the background (default!) or block your calling process until completed.","ref":"UAInspector.html#reload/1","title":"UAInspector.reload/1","type":"function"},{"doc":"Checks if a user agent is a ShellTV.","ref":"UAInspector.html#shelltv?/2","title":"UAInspector.shelltv?/2","type":"function"},{"doc":"Parse and store client hint headers for usage in device detection.","ref":"UAInspector.ClientHints.html","title":"UAInspector.ClientHints","type":"module"},{"doc":"Parse headers into a new client hint struct.\n\nAll headers are expected in dash-case (lowercase with dashes) format.\n\nLast header (if multiple possible) will be used for the result.","ref":"UAInspector.ClientHints.html#new/1","title":"UAInspector.ClientHints.new/1","type":"function"},{"doc":"","ref":"UAInspector.ClientHints.html#t:t/0","title":"UAInspector.ClientHints.t/0","type":"type"},{"doc":"Module to simplify access to configuration values with default values.\n\nThere should be no configuration required to start using `:ua_inspector` if\nyou rely on the default values:\n\n    remote_database = \"https://raw.githubusercontent.com/matomo-org/device-detector/6.1.5/regexes\"\n    remote_shortcode = \"https://raw.githubusercontent.com/matomo-org/device-detector/6.1.5\"\n\n    config :ua_inspector,\n      database_path: Application.app_dir(:ua_inspector, \"priv\"),\n      http_opts: [],\n      remote_path: [\n        bot: remote_database,\n        browser_engine: remote_database   \"/client\",\n        client: remote_database   \"/client\",\n        client_hints: remote_database   \"/client/hints\",\n        device: remote_database   \"/device\",\n        os: remote_database,\n        short_code_map: remote_shortcode,\n        vendor_fragment: remote_database\n      ],\n      remote_release: \"6.1.5\",\n      startup_silent: false,\n      startup_sync: true,\n      yaml_file_reader: {:yamerl_constr, :file, [[:str_node_as_binary]]}\n\nThe default `:database_path` is evaluated at runtime and not compiled into\na release!","ref":"UAInspector.Config.html","title":"UAInspector.Config","type":"module"},{"doc":"There are two ways to change the configuration values with the preferred way\ndepending on your environment and personal taste.\n\n#","ref":"UAInspector.Config.html#module-how-to-configure","title":"How to Configure - UAInspector.Config","type":"module"},{"doc":"If you can ensure the configuration are static and not dependent on i.e. the\nserver your application is running on, you can use a static approach by\nmodifying your `config.exs` file:\n\n    config :ua_inspector,\n      database_path: \"/path/to/ua_inspector/databases\"\n\n#","ref":"UAInspector.Config.html#module-static-configuration","title":"Static Configuration - UAInspector.Config","type":"module"},{"doc":"If a compile time configuration is not possible or does not match the usual\napproach taken in your application you can use a runtime approach.\n\nThis is done by defining an initializer module that will automatically be\ncalled by `UAInspector.Supervisor` upon startup/restart. The configuration\nis expected to consist of a `{mod, fun}` or `{mod, fun, args}` tuple:\n\n    # {mod, fun}\n    config :ua_inspector,\n      init: {MyInitModule, :my_init_mf}\n\n    # {mod, fun, args}\n    config :ua_inspector,\n      init: {MyInitModule, :my_init_mfargs, [:foo, :bar]}\n\n    defmodule MyInitModule do\n      @spec my_init_mf() :: :ok\n      def my_init_mf(), do: my_init_mfargs(:foo, :bar)\n\n      @spec my_init_mfargs(atom, atom) :: :ok\n      def my_init_mfargs(:foo, :bar) do\n        priv_dir = Application.app_dir(:my_app, \"priv\")\n\n        Application.put_env(:ua_inspector, :database_path, priv_dir)\n      end\n    end\n\nThe function is required to always return `:ok`.","ref":"UAInspector.Config.html#module-dynamic-configuration","title":"Dynamic Configuration - UAInspector.Config","type":"module"},{"doc":"By default the database files will be read during application startup.\n\nYou can change this behaviour by configuring an immediate asynchronous reload:\n\n    config :ua_inspector,\n      startup_sync: false\n\nThis can lead to the first parsing calls to work with an empty database\nand therefore not return the results you expect.\n\n#","ref":"UAInspector.Config.html#module-startup-behaviour","title":"Startup Behaviour - UAInspector.Config","type":"module"},{"doc":"When starting the application you will receive messages via `Logger.info/1`\nunder certain circumstances:\n\n- a database file fails to be parsed\n- a database file contains no entries\n- you are using the default database and the release version tracked by the\n  mix download task is different from the current default release\n\nIf you want to prevent these messages you can configure the startup the be\ncompletely silent:\n\n    config :ua_inspector,\n      startup_silent: true","ref":"UAInspector.Config.html#module-starting-silently","title":"Starting Silently - UAInspector.Config","type":"module"},{"doc":"Configuring the database to use can be done using two related values:\n\n- `:database_path`\n- `:remote_path`\n\nThe `:database_path` is the directory to look for when loading the databases.\nIt is also the place where `UAInspector.Downloader` stores a downloaded copy.\n\nFor the time being the detailed list of database files is not configurable.\nThis is a major caveat for personal database copies and short code mappings\n(they have additional path information appended to the base). This behaviour\nis subject to change.\n\nThe full configuration for remote paths contains the following values:\n\n    config :ua_inspector,\n      remote_path: [\n        bot: \"http://example.com\",\n        browser_engine: \"http://example.com\",\n        client: \"http://example.com\",\n        client_hints: \"http://example.com\",\n        device: \"http://example.com\",\n        os: \"http://example.com\",\n        short_code_map: \"http://example.com\",\n        vendor_fragment: \"http://example.com\"\n      ]\n\n#","ref":"UAInspector.Config.html#module-database-configuration","title":"Database Configuration - UAInspector.Config","type":"module"},{"doc":"If you are using the default configuration the release `\"6.1.5\"`\nwill be used. You can specify a different version/tag/release to be used:\n\n    config :ua_inspector,\n      remote_release: \"v1.0.0\"\n\nPlease be aware that using a non-default release can lead to unexpected\nresults based on the specific changes between the releases.\n\nIf the default release changes (expect this to be the case with every\nrelease of UAInspector) you should download a new copy of the database\nand/or update your own release configuration. As the list of used files\nor special in-code detections can change with each release there may\notherwise be unexpected messages during application startup or incorrect\nresults from agent detection.","ref":"UAInspector.Config.html#module-default-database-release-version","title":"Default Database Release Version - UAInspector.Config","type":"module"},{"doc":"Using the default configuration all download requests for your database files\nare done using [`:hackney`](https://hex.pm/packages/hackney). To pass custom\nconfiguration values to hackney you can use the key `:http_opts`:\n\n    # increase download timeout to 10 seconds (default: 5 seconds)\n    config :ua_inspector,\n      http_opts: [recv_timeout: 10_000]\n\nPlease look at `:hackney.request/5` for a complete list of available options.\n\nIf you want to change the library used to download the databases you can\nconfigure a module implementing the `UAInspector.Downloader.Adapter`\nbehaviour:\n\n    config :ua_inspector,\n      downloader_adapter: MyDownloaderAdapter","ref":"UAInspector.Config.html#module-download-configuration","title":"Download Configuration - UAInspector.Config","type":"module"},{"doc":"By default the library [`:yamerl`](https://hex.pm/packages/yamerl) will\nbe used to read and decode the YAML database files. You can configure this\nreader to be a custom module:\n\n    config :ua_inspector,\n      yaml_file_reader: {module, function}\n\n    config :ua_inspector,\n      yaml_file_reader: {module, function, extra_args}\n\nThe configured module will receive the file to read as the first argument with\nany optionally configured extra arguments after that.","ref":"UAInspector.Config.html#module-yaml-file-reader-configuration","title":"YAML File Reader Configuration - UAInspector.Config","type":"module"},{"doc":"Returns the configured database path.\n\nIf the path is not defined the `priv` dir of `:ua_inspector`\nas returned by `Application.app_dir(:ua_inspector, \"priv\")` will be used.","ref":"UAInspector.Config.html#database_path/0","title":"UAInspector.Config.database_path/0","type":"function"},{"doc":"Returns the remote url of a database file.","ref":"UAInspector.Config.html#database_url/2","title":"UAInspector.Config.database_url/2","type":"function"},{"doc":"Returns whether the remote database (at least one type) matches the default.","ref":"UAInspector.Config.html#default_remote_database?/0","title":"UAInspector.Config.default_remote_database?/0","type":"function"},{"doc":"Returns the configured downloader adapter module.\n\nThe modules is expected to adhere to the behaviour defined in\n`UAInspector.Downloader.Adapter`.","ref":"UAInspector.Config.html#downloader_adapter/0","title":"UAInspector.Config.downloader_adapter/0","type":"function"},{"doc":"Provides access to configuration values with optional environment lookup.","ref":"UAInspector.Config.html#get/2","title":"UAInspector.Config.get/2","type":"function"},{"doc":"Calls the optionally configured init method.","ref":"UAInspector.Config.html#init_env/0","title":"UAInspector.Config.init_env/0","type":"function"},{"doc":"Returns the currently configured remote release version.","ref":"UAInspector.Config.html#remote_release/0","title":"UAInspector.Config.remote_release/0","type":"function"},{"doc":"Returns the `{mod, fun, extra_args}` to be used when reading a YAML file.","ref":"UAInspector.Config.html#yaml_file_reader/0","title":"UAInspector.Config.yaml_file_reader/0","type":"function"},{"doc":"This supervisor module takes care of starting the required database storage\nprocesses. It is automatically started with the `:ua_inspector` application.\n\nIf you do not want to automatically start the application itself you can\nadapt your configuration for a more manual supervision approach.\n\nInstead of adding `:ua_inspector` to your `:applications` list or using\nthe automatic discovery you need to add it to your `:included_applications`:\n\n    def application do\n      [\n        included_applications: [\n          # ...\n          :ua_inspector,\n          # ...\n        ]\n      ]\n    end\n\nThat done you can add `UAInspector.Supervisor` to your hierarchy:\n\n    children = [\n      # ...\n      UAInspector.Supervisor,\n      # ..\n    ]","ref":"UAInspector.Supervisor.html","title":"UAInspector.Supervisor","type":"module"},{"doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"UAInspector.Supervisor.html#child_spec/1","title":"UAInspector.Supervisor.child_spec/1","type":"function"},{"doc":"Fetches copies of the configured database files.\n\nAll files will be stored in the configured database path with the default\nsetting being the result of `Application.app_dir(:ua_inspector, \"priv\")`.\n\nPlease consult `UAInspector.Config` for details on database configuration.","ref":"UAInspector.Downloader.html","title":"UAInspector.Downloader","type":"module"},{"doc":"Please see `Mix.Tasks.UaInspector.Download` if you are interested in\nusing a mix task to obtain your database files.","ref":"UAInspector.Downloader.html#module-mix-task","title":"Mix Task - UAInspector.Downloader","type":"module"},{"doc":"Performs download of all files.","ref":"UAInspector.Downloader.html#download/0","title":"UAInspector.Downloader.download/0","type":"function"},{"doc":"Performs download of configured database files and short code maps.","ref":"UAInspector.Downloader.html#download/1","title":"UAInspector.Downloader.download/1","type":"function"},{"doc":"Behaviour for modules used by the downloader.","ref":"UAInspector.Downloader.Adapter.html","title":"UAInspector.Downloader.Adapter","type":"behaviour"},{"doc":"Reads a database file from a remote location and returns its contents.","ref":"UAInspector.Downloader.Adapter.html#c:read_remote/1","title":"UAInspector.Downloader.Adapter.read_remote/1","type":"callback"},{"doc":"Result struct.","ref":"UAInspector.Result.html","title":"UAInspector.Result","type":"module"},{"doc":"","ref":"UAInspector.Result.html#t:t/0","title":"UAInspector.Result.t/0","type":"type"},{"doc":"Bot result struct.","ref":"UAInspector.Result.Bot.html","title":"UAInspector.Result.Bot","type":"module"},{"doc":"","ref":"UAInspector.Result.Bot.html#t:t/0","title":"UAInspector.Result.Bot.t/0","type":"type"},{"doc":"Bot producer result struct.","ref":"UAInspector.Result.BotProducer.html","title":"UAInspector.Result.BotProducer","type":"module"},{"doc":"","ref":"UAInspector.Result.BotProducer.html#t:t/0","title":"UAInspector.Result.BotProducer.t/0","type":"type"},{"doc":"Client result struct.","ref":"UAInspector.Result.Client.html","title":"UAInspector.Result.Client","type":"module"},{"doc":"","ref":"UAInspector.Result.Client.html#t:t/0","title":"UAInspector.Result.Client.t/0","type":"type"},{"doc":"Device result struct.","ref":"UAInspector.Result.Device.html","title":"UAInspector.Result.Device","type":"module"},{"doc":"","ref":"UAInspector.Result.Device.html#t:t/0","title":"UAInspector.Result.Device.t/0","type":"type"},{"doc":"Operating system result struct.","ref":"UAInspector.Result.OS.html","title":"UAInspector.Result.OS","type":"module"},{"doc":"","ref":"UAInspector.Result.OS.html#t:t/0","title":"UAInspector.Result.OS.t/0","type":"type"},{"doc":"# Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"- Enhancements\n    - Default upstream database version is now `6.1.5`\n    - Special handling to detect the correct browser engine (and version) for a combination of a \"Blink\" style user agent and application client hint header has been integrated\n    - Upstream improvements for TV device detection have been integrated","ref":"changelog.html#v3-5-0-2023-08-22","title":"v3.5.0 (2023-08-22) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Default upstream database version is now `6.1.4`\n    - Upstream improvements to detect device brand, if only model is found in client hints, have been integrated","ref":"changelog.html#v3-4-0-2023-08-06","title":"v3.4.0 (2023-08-06) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Default upstream database version is now `6.1.3`","ref":"changelog.html#v3-3-1-2023-06-06","title":"v3.3.1 (2023-06-06) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Default upstream database version is now `6.1.2`\n    - Upstream improvements to handle fake user agents (\"Android\" + \"Apple\" combination) have been integrated","ref":"changelog.html#v3-3-0-2023-05-19","title":"v3.3.0 (2023-05-19) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Default upstream database version is now `6.1.1`","ref":"changelog.html#v3-2-1-2023-03-17","title":"v3.2.1 (2023-03-17) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Default upstream database version is now `6.1.0`\n    - Upstream improvements to detect tablet devices have been integrated\n    - Using the mix download task with a default database will save the `:remote_release` configured during download. If the version differs from the current default upon application startup, a `Logger.info/1` will be issued unless `startup_silent = true` is configured","ref":"changelog.html#v3-2-0-2023-03-04","title":"v3.2.0 (2023-03-04) - Changelog","type":"extras"},{"doc":"- Bug fixes\n    - Devices containing `(lite) TV` in their agent are now properly identified as TV devices if more detailed information is not available","ref":"changelog.html#v3-1-1-2023-02-20","title":"v3.1.1 (2023-02-20) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Allow checking if a user agent is a known desktop device using `UAInspector.desktop?/1`\n    - Allow checking if a user agent is a known mobile device using `UAInspector.mobile?/1`\n    - Default upstream database version is now `6.0.6`\n    - Parser results can be passed directly to `UAInspector.bot?/1`, `UAInspector.hbbtv?/1`, and `UAInspector.shelltv?/1`\n    - Added support to use client hint headers for improved detection\n    - Upstream improvements to detect engine versions of \"Blink\" type browsers have been integrated\n    - Upstream improvements to detect ShellTV devices have been integrated\n    - Upstream improvements to detect x64 devices using Windows have been integrated\n    - Upstream improvements to detect generic TV devices have been integrated","ref":"changelog.html#v3-1-0-2023-02-12","title":"v3.1.0 (2023-02-12) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Default upstream database version is now `5.0.5`","ref":"changelog.html#v3-0-1-2022-03-08","title":"v3.0.1 (2022-03-08) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Default upstream database version is now `5.0.4`\n    - If a database or short code map contains no (zero) entries during startup/reload a `Logger.info/1` will be sent unless `startup_silent = true` is configured\n\n- Backwards incompatible changes\n    - Minimum required Elixir version is now `~> 1.9`\n    - The (default) `:hackney` download adapter will now only accept responses with \"200 OK\". Depending on your environment it could be required to configure following redirects using `http_opts: [follow_redirect: true]`","ref":"changelog.html#v3-0-0-2022-03-06","title":"v3.0.0 (2022-03-06) - Changelog","type":"extras"},{"doc":"Default download database version has been pinned to \"release 3.13.1\" after major changes in the upstream sources ([matomo-org/device-detector](https://github.com/matomo-org/device-detector) moving towards a new major release).\n\nThere will be a new major version of `ua_inspector` with a rebuilt database support for `matomo-org/device-detector@v4.x` and/or a separate database built upon these sources to simplify future upgrades.\n\n- Enhancements\n    - Upstream improvements to detect engine versions of \"Gecko\" type browsers have been integrated\n\n- Bug fixes\n    - Brand names are now always returned as strings (as expected), even if parsed as numbers from the YAML database","ref":"changelog.html#v2-2-0-2020-10-29","title":"v2.2.0 (2020-10-29) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - New \"desktop notebook\" devices are detected\n    - Upstream improvements to detect mobile apps using Chrome have been integrated","ref":"changelog.html#v2-1-0-2020-08-17","title":"v2.1.0 (2020-08-17) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Detection will now make use of \"browser families\" to match upstream improvements for Chrome based devices\n    - If detectable the \"browser family\" of a client is now available as `:browser_family` in the result struct\n    - If detectable the \"operating system family\" of a client is now available as `:os_family` in the result struct\n\n- Bug fixes\n    - The mix download task should no longer start unnecessary applications ([#19](https://github.com/elixir-inspector/ua_inspector/issues/19))\n\n- Backwards incompatible changes\n    - Minimum required Elixir version is now `~> 1.7`\n    - Several deprecated functions have been removed completely:\n        - `UAInspector.Downloader.prepare_database_path/0`\n        - `UAInspector.Downloader.read_remote/0`\n        - `UAInspector.Downloader.README.path_local/0`\n        - `UAInspector.Downloader.README.path_priv/0`\n    - Startup is now done with a blocking database load by default","ref":"changelog.html#v2-0-0-2020-05-29","title":"v2.0.0 (2020-05-29) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Warnings when starting without a database available can be silenced\n\n- Bug fixes\n    - The mix download task now works properly with initializer modules ([#18](https://github.com/elixir-inspector/ua_inspector/issues/18))","ref":"changelog.html#v1-2-0-2019-08-10","title":"v1.2.0 (2019-08-10) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Configuring `startup_sync: true` allows you to ensure a synchronous database load is attempted before allowing to parse user agents\n    - Database entries are now stored in a single named table instead of using an intermediate reference table\n    - Output of mix task `ua_inspector.download` can be prevented by passing `--quiet` upon invocation. This does NOT imply `--force` and will still ask for confirmation\n    - Passing `async: false` to `UAInspector.reload/1` allows you to block your calling process until the reload has finished\n    - The library used to download the database files can be changed by configuring a module implementing the `UAInspector.Downloader.Adapter` behaviour\n    - The library used to read YAML files can be changed by using the `:yaml_file_reader` configuration\n\n- Bug fixes\n    - Matching the documentation the informational README file created by the downloader will now only be created when using the mix task\n\n- Deprecations\n    - Several functions are now declared internal and will result in a `Logger.info/1` message when called until they will be eventually removed:\n        - `UAInspector.Downloader.prepare_database_path/0`\n        - `UAInspector.Downloader.read_remote/0`\n        - `UAInspector.Downloader.README.path_local/0`\n        - `UAInspector.Downloader.README.path_priv/0`","ref":"changelog.html#v1-1-0-2019-07-13","title":"v1.1.0 (2019-07-13) - Changelog","type":"extras"},{"doc":"- Ownership has been transferred to the [`elixir-inspector`](https://github.com/elixir-inspector) organisation\n\n- Enhancements\n    - Documentation is now available inline (`@moduledoc`, ...) with the `README.md` file targeting the repository (development) instead of releases\n    - The default database path has been set to `Application.app_dir(:ua_inspector, \"priv\")`\n\n- Backwards incompatible changes\n    - Internal parser process pooling has been removed. If you require pooling you need to manually wrap `UAInspector.parse/1` (and related functions)\n    - Minimum required Elixir version is now `~> 1.5`\n    - Support for `{:system, var}` configuration has been removed\n    - The deprecated mix tasks `ua_inspector.download.databases` and `ua_inspector.download.short_code_maps` have been removed","ref":"changelog.html#v1-0-0-2019-04-20","title":"v1.0.0 (2019-04-20) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Initializer modules can be defined with additional arguments by using `{mod, fun, args}`\n    - When using the default database you can now set a `:remote_release` to be used for downloading. The default is `\"master\"` but any valid commit from the upstream source is allowed\n\n- Deprecations\n    - Accessing the system environment by configuring `{:system, var}` or `{:system, var, default}` will now result in a `Logger.info/1` message and will stop working in a future release\n    - The download tasks `ua_inspector.download.databases` and `ua_inspector.download.short_code_maps` are now deprecated and will be removed in a future release","ref":"changelog.html#v0-20-0-2019-03-10","title":"v0.20.0 (2019-03-10) - Changelog","type":"extras"},{"doc":"- Bug fixes\n    - Short code maps are now stored in the correct file encoding (`UTF-8`) to allow parsing short code maps with characters like umlauts ([#15](https://github.com/elixir-inspector/ua_inspector/issues/15))","ref":"changelog.html#v0-19-2-2019-02-12","title":"v0.19.2 (2019-02-12) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - The (soft) deprecated download tasks `ua_inspector.download.databases` and `ua_inspector.download.short_code_maps` are no longer displayed in the output of `mix help`","ref":"changelog.html#v0-19-1-2019-01-05","title":"v0.19.1 (2019-01-05) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - All database files (parser databases and short code maps) can be downloaded using a single mix task `ua_inspector.download`\n    - Downloading the databases ensures hackney is started to allow calling `mix run --no-start -e \"UAInspector.Downloader.download()\"`\n    - Finding the data table is now done via a named lookup table instead of calling the database state server\n    - If you need to check if all databases are loaded (i.e. \"no longer empty\") you can use `UAInspector.ready?/0`\n    - OS Families are no longer hardcoded inside `Util.OS` but read from the original source and stored in a short code map\n    - OS Families used for desktop detection are no longer hardcoded inside `Util.OS` but read from the original source and stored in a short code map\n    - Reloading will now issue a warning if no database path is configured while resuming operation with an empty database\n\n- Soft deprecations (no warnings)\n    - The individual download tasks for databases and short code maps have been removed from the documentation. They are still completely functional but will eventually be removed after a proper deprecation phase","ref":"changelog.html#v0-19-0-2019-01-03","title":"v0.19.0 (2019-01-03) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Configuration can be done on supervisor (re-) start or when running the mix download tasks by setting a `{mod, fun}` tuple for the config key `:init`. This method will be called without arguments.\n    - Old data tables are deleted with a configurable delay after reloading to avoid race conditions (and the resulting empty lookup responses)\n\n- Bug fixes\n    - ETS tables of short code maps are now properly cleaned after reload\n\n- Soft deprecations (no warnings)\n    - Support for `{:system, \"ENV_VARIABLE\"}` configuration has been removed from the documentation. It will eventually be removed completely after a proper deprecation phase","ref":"changelog.html#v0-18-0-2018-08-15","title":"v0.18.0 (2018-08-15) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - References to `piwik` (like database URLs) have been updated to reflect the rename to `matomo`","ref":"changelog.html#v0-17-0-2018-02-18","title":"v0.17.0 (2018-02-18) - Changelog","type":"extras"},{"doc":"- Bug fixes\n    - Broken module naming for the mix download tasks has been fixed ([#12](https://github.com/elixir-inspector/ua_inspector/issues/12))","ref":"changelog.html#v0-16-1-2018-01-17","title":"v0.16.1 (2018-01-17) - Changelog","type":"extras"},{"doc":"- Backwards incompatible changes\n    - Minimum required Elixir version is now `~> 1.3`","ref":"changelog.html#v0-16-0-2018-01-05","title":"v0.16.0 (2018-01-05) - Changelog","type":"extras"},{"doc":"- Bug fixes\n    - Broken module naming for the mix download tasks has been fixed ([#12](https://github.com/elixir-inspector/ua_inspector/issues/12))","ref":"changelog.html#v0-15-1-2018-01-17","title":"v0.15.1 (2018-01-17) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - All databases can be reloaded (asynchronously) using `UAInspector.reload/0`\n    - Supervision can now be done without starting the application ([#8](https://github.com/elixir-inspector/ua_inspector/pulls/8))\n    - The database downloader has been promoted to a directly usable module\n\n- Bug fixes\n    - If a device has no type configured in the database previously `nil` was returned instead of the expected `:unknown`","ref":"changelog.html#v0-15-0-2017-12-30","title":"v0.15.0 (2017-12-30) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Empty user agents (`\"\"` or `nil`) now return a result without performing an actual lookup. By definition an empty user agent is never detected as a bot\n    - System environment configuration can set an optional default value to be used if the environment variable is unset\n\n- Bug fixes\n    - Properly handles `nil` values passed to the lookup functions ([#7](https://github.com/elixir-inspector/ua_inspector/issues/7))","ref":"changelog.html#v0-14-0-2017-05-31","title":"v0.14.0 (2017-05-31) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Engine versions are extracted\n    - Remote url of database files is now configurable. Due to naming changes a complete re-download is necessary\n    - Remote url of short code map files is now configurable","ref":"changelog.html#v0-13-0-2016-09-08","title":"v0.13.0 (2016-09-08) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Database downloads are done using hackney in order to prepare an upcoming auto-update feature\n    - If the initial load of a database (during process initialisation) fails a message will be sent through `Logger.info/1`\n    - If the initial load of a short code map (during process initialisation) fails a message will be sent through `Logger.info/1`\n\n- Backwards incompatible changes\n    - Completely unknown devices now yield `:unknown` instead of a struct with all values set to `:unknown`\n    - Downloads are now done using `:hackney` instead of `mix`. This may force you to manually reconfigure the client\n    - Minimum required Elixir version is now `~> 1.2`\n    - Minimum required Erlang version is now `~> 18.0`","ref":"changelog.html#v0-12-0-2016-08-18","title":"v0.12.0 (2016-08-18) - Changelog","type":"extras"},{"doc":"- Bug fixes\n    - Properly handles short code map files after upstream changes","ref":"changelog.html#v0-11-1-2016-04-02","title":"v0.11.1 (2016-04-02) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Databases are reloaded if a storage process gets restarted\n    - HbbTV version can be fetched using `hbbtv?/1`\n    - Path can be configured by accessing the system environment ([#5](https://github.com/elixir-inspector/ua_inspector/pull/5))\n    - Short code mappings are reloaded if a storage process gets restarted","ref":"changelog.html#v0-11-0-2016-03-28","title":"v0.11.0 (2016-03-28) - Changelog","type":"extras"},{"doc":"- Bug fixes\n    - Fixes problems with mix tasks under case insensitive file systems","ref":"changelog.html#v0-10-0-2015-11-10","title":"v0.10.0 (2015-11-10) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Convenience method to check if user agent belongs to a bot (`bot?/1`)\n    - Convenience method to parse without checking for bots (`parse_client/1`)\n    - Operating system platform included in result","ref":"changelog.html#v0-9-0-2015-10-17","title":"v0.9.0 (2015-10-17) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Bots are included in the detection\n    - Short code mappings are fetched and parsed on demand\n\n- Backwards incompatible changes\n    - Short code maps are no longer included in the repository\n    - Renamed mix task `databases.download` to `download.databases`","ref":"changelog.html#v0-8-0-2015-07-09","title":"v0.8.0 (2015-07-09) - Changelog","type":"extras"},{"doc":"- Enhancements\n    - Dependencies not used in production builds are marked as optional\n    - Displays expanded download path for `mix ua_inspector.databases.download`\n    - Verification script now automatically downloads database files\n    - Worker pool options are no longer defined at compile time\n\n- Backwards incompatible changes\n    - Pool configuration is now expected to be a `Keyword.t`","ref":"changelog.html#v0-7-0-2015-05-31","title":"v0.7.0 (2015-05-31) - Changelog","type":"extras"},{"doc":"- Initial Release","ref":"changelog.html#v0-6-0-2015-04-06","title":"v0.6.0 (2015-04-06) - Changelog","type":"extras"},{"doc":"Apache License\n                        Version 2.0, January 2004\n                     http://www.apache.org/licenses/\n\nTERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n1. Definitions.\n\n   \"License\" shall mean the terms and conditions for use, reproduction,\n   and distribution as defined by Sections 1 through 9 of this document.\n\n   \"Licensor\" shall mean the copyright owner or entity authorized by\n   the copyright owner that is granting the License.\n\n   \"Legal Entity\" shall mean the union of the acting entity and all\n   other entities that control, are controlled by, or are under common\n   control with that entity. For the purposes of this definition,\n   \"control\" means (i) the power, direct or indirect, to cause the\n   direction or management of such entity, whether by contract or\n   otherwise, or (ii) ownership of fifty percent (50%) or more of the\n   outstanding shares, or (iii) beneficial ownership of such entity.\n\n   \"You\" (or \"Your\") shall mean an individual or Legal Entity\n   exercising permissions granted by this License.\n\n   \"Source\" form shall mean the preferred form for making modifications,\n   including but not limited to software source code, documentation\n   source, and configuration files.\n\n   \"Object\" form shall mean any form resulting from mechanical\n   transformation or translation of a Source form, including but\n   not limited to compiled object code, generated documentation,\n   and conversions to other media types.\n\n   \"Work\" shall mean the work of authorship, whether in Source or\n   Object form, made available under the License, as indicated by a\n   copyright notice that is included in or attached to the work\n   (an example is provided in the Appendix below).\n\n   \"Derivative Works\" shall mean any work, whether in Source or Object\n   form, that is based on (or derived from) the Work and for which the\n   editorial revisions, annotations, elaborations, or other modifications\n   represent, as a whole, an original work of authorship. For the purposes\n   of this License, Derivative Works shall not include works that remain\n   separable from, or merely link (or bind by name) to the interfaces of,\n   the Work and Derivative Works thereof.\n\n   \"Contribution\" shall mean any work of authorship, including\n   the original version of the Work and any modifications or additions\n   to that Work or Derivative Works thereof, that is intentionally\n   submitted to Licensor for inclusion in the Work by the copyright owner\n   or by an individual or Legal Entity authorized to submit on behalf of\n   the copyright owner. For the purposes of this definition, \"submitted\"\n   means any form of electronic, verbal, or written communication sent\n   to the Licensor or its representatives, including but not limited to\n   communication on electronic mailing lists, source code control systems,\n   and issue tracking systems that are managed by, or on behalf of, the\n   Licensor for the purpose of discussing and improving the Work, but\n   excluding communication that is conspicuously marked or otherwise\n   designated in writing by the copyright owner as \"Not a Contribution.\"\n\n   \"Contributor\" shall mean Licensor and any individual or Legal Entity\n   on behalf of whom a Contribution has been received by Licensor and\n   subsequently incorporated within the Work.\n\n2. Grant of Copyright License. Subject to the terms and conditions of\n   this License, each Contributor hereby grants to You a perpetual,\n   worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n   copyright license to reproduce, prepare Derivative Works of,\n   publicly display, publicly perform, sublicense, and distribute the\n   Work and such Derivative Works in Source or Object form.\n\n3. Grant of Patent License. Subject to the terms and conditions of\n   this License, each Contributor hereby grants to You a perpetual,\n   worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n   (except as stated in this section) patent license to make, have made,\n   use, offer to sell, sell, import, and otherwise transfer the Work,\n   where such license applies only to those patent claims licensable\n   by such Contributor that are necessarily infringed by their\n   Contribution(s) alone or by combination of their Contribution(s)\n   with the Work to which such Contribution(s) was submitted. If You\n   institute patent litigation against any entity (including a\n   cross-claim or counterclaim in a lawsuit) alleging that the Work\n   or a Contribution incorporated within the Work constitutes direct\n   or contributory patent infringement, then any patent licenses\n   granted to You under this License for that Work shall terminate\n   as of the date such litigation is filed.\n\n4. Redistribution. You may reproduce and distribute copies of the\n   Work or Derivative Works thereof in any medium, with or without\n   modifications, and in Source or Object form, provided that You\n   meet the following conditions:\n\n   (a) You must give any other recipients of the Work or\n       Derivative Works a copy of this License; and\n\n   (b) You must cause any modified files to carry prominent notices\n       stating that You changed the files; and\n\n   (c) You must retain, in the Source form of any Derivative Works\n       that You distribute, all copyright, patent, trademark, and\n       attribution notices from the Source form of the Work,\n       excluding those notices that do not pertain to any part of\n       the Derivative Works; and\n\n   (d) If the Work includes a \"NOTICE\" text file as part of its\n       distribution, then any Derivative Works that You distribute must\n       include a readable copy of the attribution notices contained\n       within such NOTICE file, excluding those notices that do not\n       pertain to any part of the Derivative Works, in at least one\n       of the following places: within a NOTICE text file distributed\n       as part of the Derivative Works; within the Source form or\n       documentation, if provided along with the Derivative Works; or,\n       within a display generated by the Derivative Works, if and\n       wherever such third-party notices normally appear. The contents\n       of the NOTICE file are for informational purposes only and\n       do not modify the License. You may add Your own attribution\n       notices within Derivative Works that You distribute, alongside\n       or as an addendum to the NOTICE text from the Work, provided\n       that such additional attribution notices cannot be construed\n       as modifying the License.\n\n   You may add Your own copyright statement to Your modifications and\n   may provide additional or different license terms and conditions\n   for use, reproduction, or distribution of Your modifications, or\n   for any such Derivative Works as a whole, provided Your use,\n   reproduction, and distribution of the Work otherwise complies with\n   the conditions stated in this License.\n\n5. Submission of Contributions. Unless You explicitly state otherwise,\n   any Contribution intentionally submitted for inclusion in the Work\n   by You to the Licensor shall be under the terms and conditions of\n   this License, without any additional terms or conditions.\n   Notwithstanding the above, nothing herein shall supersede or modify\n   the terms of any separate license agreement you may have executed\n   with Licensor regarding such Contributions.\n\n6. Trademarks. This License does not grant permission to use the trade\n   names, trademarks, service marks, or product names of the Licensor,\n   except as required for reasonable and customary use in describing the\n   origin of the Work and reproducing the content of the NOTICE file.\n\n7. Disclaimer of Warranty. Unless required by applicable law or\n   agreed to in writing, Licensor provides the Work (and each\n   Contributor provides its Contributions) on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n   implied, including, without limitation, any warranties or conditions\n   of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n   PARTICULAR PURPOSE. You are solely responsible for determining the\n   appropriateness of using or redistributing the Work and assume any\n   risks associated with Your exercise of permissions under this License.\n\n8. Limitation of Liability. In no event and under no legal theory,\n   whether in tort (including negligence), contract, or otherwise,\n   unless required by applicable law (such as deliberate and grossly\n   negligent acts) or agreed to in writing, shall any Contributor be\n   liable to You for damages, including any direct, indirect, special,\n   incidental, or consequential damages of any character arising as a\n   result of this License or out of the use or inability to use the\n   Work (including but not limited to damages for loss of goodwill,\n   work stoppage, computer failure or malfunction, or any and all\n   other commercial damages or losses), even if such Contributor\n   has been advised of the possibility of such damages.\n\n9. Accepting Warranty or Additional Liability. While redistributing\n   the Work or Derivative Works thereof, You may choose to offer,\n   and charge a fee for, acceptance of support, warranty, indemnity,\n   or other liability obligations and/or rights consistent with this\n   License. However, in accepting such obligations, You may act only\n   on Your own behalf and on Your sole responsibility, not on behalf\n   of any other Contributor, and only if You agree to indemnify,\n   defend, and hold each Contributor harmless for any liability\n   incurred by, or claims asserted against, such Contributor by reason\n   of your accepting any such warranty or additional liability.\n\nEND OF TERMS AND CONDITIONS","ref":"license.html","title":"License","type":"extras"},{"doc":"# UAInspector\n\n[![Test](https://github.com/elixir-inspector/ua_inspector/actions/workflows/test.yml/badge.svg)](https://github.com/elixir-inspector/ua_inspector/actions/workflows/test.yml)\n[![Module Version](https://img.shields.io/hexpm/v/ua_inspector.svg)](https://hex.pm/packages/ua_inspector)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/ua_inspector/)\n[![Total Downloads](https://img.shields.io/hexpm/dt/ua_inspector.svg)](https://hex.pm/packages/ua_inspector)\n[![License](https://img.shields.io/hexpm/l/ua_inspector.svg)](https://github.com/elixir-inspector/ua_inspector/blob/master/LICENSE)\n[![Last Updated](https://img.shields.io/github/last-commit/elixir-inspector/ua_inspector.svg)](https://github.com/elixir-inspector/ua_inspector/commits/master)\n\nUser agent parser library.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"To use UAInspector with your projects, edit your `mix.exs` file and add the required dependencies:\n\n```elixir\ndefp deps do\n  [\n    # ...\n    {:ua_inspector, \"~> 3.0\"},\n    # ...\n  ]\nend\n```\n\nIf you want to use a manual supervision approach (without starting the application) please look at the inline documentation of `UAInspector.Supervisor`.","ref":"readme.html#package-setup","title":"Package Setup - Overview","type":"extras"},{"doc":"Out of the box the default database files will be stored in the `:priv_dir` of `:ua_inspector`. Both the database sources and path used can be changed.\n\nFor a detailed list of available configuration options please consult `UAInspector.Config`.","ref":"readme.html#application-configuration","title":"Application Configuration - Overview","type":"extras"},{"doc":"#","ref":"readme.html#basic-usage","title":"Basic Usage - Overview","type":"extras"},{"doc":"You need to obtain a copy of the configured databases by calling either `mix ua_inspector.download` from the command line or `UAInspector.Downloader.download/0` from within your application.\n\nRefer to `UAInspector.Downloader` for more details.\n\n#","ref":"readme.html#database-download","title":"Database Download - Overview","type":"extras"},{"doc":"```elixir\niex> UAInspector.parse(\"Mozilla/5.0 (iPad; CPU OS 7_0_4 like Mac OS X) AppleWebKit/537.51.1 (KHTML, like Gecko) Version/7.0 Mobile/11B554a Safari/9537.53\")\n%UAInspector.Result{\n  client: %UAInspector.Result.Client{\n    engine: \"WebKit\",\n    engine_version: \"537.51.1\",\n    name: \"Mobile Safari\",\n    type: \"browser\",\n    version: \"7.0\"\n  },\n  device: %UAInspector.Result.Device{\n    brand: \"Apple\",\n    model: \"iPad\",\n    type: \"tablet\"\n  },\n  os: %UAInspector.Result.OS{\n    name: \"iOS\",\n    platform: :unknown,\n    version: \"7.0.4\"\n  },\n  user_agent: \"Mozilla/5.0 (iPad; CPU OS 7_0_4 like Mac OS X) AppleWebKit/537.51.1 (KHTML, like Gecko) Version/7.0 Mobile/11B554a Safari/9537.53\"\n}\n\niex> UAInspector.parse(\"Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36\")\n%UAInspector.Result.Bot{\n  category: \"Search bot\",\n  name: \"Googlebot\",\n  producer: %UAInspector.Result.BotProducer{\n    name: \"Google Inc.\",\n    url: \"http://www.google.com\"\n  },\n  url: \"http://www.google.com/bot.html\",\n  user_agent: \"Mozilla/5.0 AppleWebKit/537.36 (KHTML, like Gecko; compatible; Googlebot/2.1; +http://www.google.com/bot.html) Safari/537.36\"\n}\n```\n\nFull documentation is available inline in the `UAInspector` module and at [https://hexdocs.pm/ua_inspector](https://hexdocs.pm/ua_inspector).","ref":"readme.html#user-agent-parsing","title":"User Agent Parsing - Overview","type":"extras"},{"doc":"Several (minimal) benchmark scripts are included. Please refer to the Mixfile or `mix help` output for their names.","ref":"readme.html#benchmark","title":"Benchmark - Overview","type":"extras"},{"doc":"- [matomo-org/device-detector](https://github.com/matomo-org/device-detector)","ref":"readme.html#resources","title":"Resources - Overview","type":"extras"},{"doc":"Copyright (c) 2013 Marc Neudert\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at [http://www.apache.org/licenses/LICENSE-2.0](http://www.apache.org/licenses/LICENSE-2.0)\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.\n\nThe parser databases are taken from the [matomo-org/device-detector](https://github.com/matomo-org/device-detector) project. See there for detailed license information about the data contained.","ref":"readme.html#copyright-and-license","title":"Copyright and License - Overview","type":"extras"}]}